=== debian/changelog ===
nvidia-cutlass (3.4.1+ds-2) unstable; urgency=medium

  * Install missing files needed for pytorch-cuda.

 -- Mo Zhou <lumin@debian.org>  Sun, 24 Nov 2024 13:20:18 -0500

nvidia-cutlass (3.4.1+ds-1) unstable; urgency=medium

  * New upstream version 3.4.1
    Please pin to this version for PyTorch/v2.4.X release.

 -- Mo Zhou <lumin@debian.org>  Thu, 03 Oct 2024 01:19:38 -0400
